diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/backend.py anaconda-storage/backend.py
--- anaconda/backend.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/backend.py	2009-02-15 13:50:08.000000000 -0600
@@ -156,8 +156,9 @@
         if not anaconda.mediaDevice or not os.path.exists(installimg):
             return
 
+        free = anaconda.id.storage.fsset.fsFreeSpace(anaconda.rootPath)
         self._loopbackFile = "%s%s/rhinstall-install.img" % (anaconda.rootPath,
-                             anaconda.id.fsset.filesystemSpace(anaconda.rootPath)[0][0])
+                                                             free[0][0])
 
         try:
             win = anaconda.intf.waitWindow(_("Copying File"),
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/bootloader.py anaconda-storage/bootloader.py
--- anaconda/bootloader.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/bootloader.py	2009-02-17 12:41:56.000000000 -0600
@@ -60,49 +60,36 @@
         anaconda.id.bootloader.updateDriveList(pref)
 
     if iutil.isEfi() and not anaconda.id.bootloader.device:
-        drives = anaconda.id.diskset.disks.keys()
-        drives.sort()
         bootPart = None
-        for drive in drives:
-            disk = anaconda.id.diskset.disks[drive]
-            for part in disk.partitions:
-                if part.active and partedUtils.isEfiSystemPartition(part):
-                    bootPart = part.getDeviceNodeName()
+        partitions = anaconda.id.storage.partitions
+        for part in partitions:
+            if part.partedPartition.active and \
+               partedUtils.isEfiSystemPartition(part.partedPartition):
+                    bootPart = part.name
                     break
-            if bootPart:
-                break
         if bootPart:
             anaconda.id.bootloader.setDevice(bootPart)
-            dev = Device()
-            dev.device = bootPart
-            anaconda.id.fsset.add(FileSystemSetEntry(dev, None, fileSystemTypeGet("efi")))
 
 # iSeries bootloader on upgrades
     if iutil.getPPCMachine() == "iSeries" and not anaconda.id.bootloader.device:
-        drives = anaconda.id.diskset.disks.keys()
-        drives.sort()
         bootPart = None
-        for drive in drives:
-            disk = anaconda.id.diskset.disks[drive]
-            for part in disk.partitions:
-                if part.active and part.getFlag(parted.PARTITION_PREP):
-                    bootPart = part.getDeviceNodeName()
-                    break
-            if bootPart:
+        partitions = anaconda.id.storage.partitions
+        for part in partitions:
+            if part.partedPartition.active and \
+               part.partedPartition.getFlag(parted.PARTITION_PREP):
+                bootPart = part.name
                 break
         if bootPart:
             anaconda.id.bootloader.setDevice(bootPart)
-            dev = Device()
-            dev.device = bootPart
-            anaconda.id.fsset.add(FileSystemSetEntry(dev, None, fileSystemTypeGet("PPC PReP Boot")))
 
-    choices = anaconda.id.fsset.bootloaderChoices(anaconda.id.diskset, anaconda.id.bootloader)
+    choices = anaconda.id.storage.fsset.bootloaderChoices(anaconda.id.bootloader)
     if not choices and iutil.getPPCMachine() != "iSeries":
 	anaconda.dispatch.skipStep("instbootloader")
     else:
 	anaconda.dispatch.skipStep("instbootloader", skip = 0)
 
-    anaconda.id.bootloader.images.setup(anaconda.id.diskset, anaconda.id.fsset)
+    # FIXME: ...
+    anaconda.id.bootloader.images.setup(anaconda.id.storage)
 
     if anaconda.id.bootloader.defaultDevice != None and choices:
         keys = choices.keys()
@@ -150,11 +137,7 @@
 
     kernelList = []
     otherList = []
-    root = anaconda.id.fsset.getEntryByMountPoint('/')
-    if root:
-        rootDev = root.device.getDevice()
-    else:
-        rootDev = None
+    rootDev = getattr(anaconda.id.rootDevice, "path", None)
     defaultDev = anaconda.id.bootloader.images.getDefault()
 
     kernelLabel = None
@@ -204,8 +187,10 @@
 
     dosync()
     try:
-        anaconda.id.bootloader.write(anaconda.rootPath, anaconda.id.fsset, anaconda.id.bootloader,
-                                     anaconda.id.instLanguage, kernelList, otherList, defaultDev,
+        anaconda.id.bootloader.write(anaconda.rootPath, anaconda.id.storage,
+                                     anaconda.id.bootloader,
+                                     anaconda.id.instLanguage,
+                                     kernelList, otherList, defaultDev,
                                      justConfigFile, anaconda.intf)
 	if not justConfigFile:
 	    w.pop()
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/cmdline.py anaconda-storage/cmdline.py
--- anaconda/cmdline.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/cmdline.py	2009-02-15 14:45:19.000000000 -0600
@@ -114,10 +114,6 @@
         pass
 
     def run(self, anaconda):
-        anaconda.id.fsset.registerMessageWindow(self.messageWindow)
-        anaconda.id.fsset.registerProgressWindow(self.progressWindow)
-        anaconda.id.fsset.registerWaitWindow(self.waitWindow)        
-
         (step, instance) = anaconda.dispatch.currentStep()
         while step:
             if stepToClasses.has_key(step):
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/gui.py anaconda-storage/gui.py
--- anaconda/gui.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/gui.py	2009-02-15 15:04:24.000000000 -0600
@@ -752,7 +752,7 @@
         elif len(dests) > 0:
             for d in dests:
                 iter = store.append(None)
-                store[iter] = ("/dev/%s" % d[0], "/dev/%s - %s" % (d[0], d[1]))
+                store[iter] = (d[0], "%s - %s" % (d[0], d[1]))
 
             self.diskCombo.set_model(store)
             self.diskCombo.set_active(0)
@@ -1267,10 +1267,6 @@
         if anaconda.id.keyboard and not anaconda.id.x_already_set:
             anaconda.id.keyboard.activate()
 
-        anaconda.id.fsset.registerMessageWindow(self.messageWindow)
-        anaconda.id.fsset.registerProgressWindow(self.progressWindow)
-        anaconda.id.fsset.registerWaitWindow(self.waitWindow)
-
         self.icw = InstallControlWindow (self.anaconda)
         self.icw.run (self.runres)
 
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/installclass.py anaconda-storage/installclass.py
--- anaconda/installclass.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/installclass.py	2009-02-15 15:14:18.000000000 -0600
@@ -188,11 +188,11 @@
         from backend import AnacondaBackend
         return AnacondaBackend
 
-    def setDefaultPartitioning(self, partitions, clear = CLEARPART_TYPE_LINUX,
+    def setDefaultPartitioning(self, storage, clear = CLEARPART_TYPE_LINUX,
                                doClear = 1, useLVM = True):
         autorequests = [ ("/", None, 1024, None, 1, 1, 1) ]
 
-        bootreq = getAutopartitionBoot(partitions)
+        bootreq = getAutopartitionBoot(storage)
         if bootreq:
             autorequests.extend(bootreq)
 
@@ -200,13 +200,13 @@
         autorequests.append((None, "swap", minswap, maxswap, 1, 1, 1))
 
         if doClear:
-            partitions.autoClearPartType = clear
-            partitions.autoClearPartDrives = []
+            storage.autoClearPartType = clear
+            storage.autoClearPartDrives = []
 
         if useLVM:
-            partitions.autoPartitionRequests = autoCreateLVMPartitionRequests(autorequests)
+            storage.autoPartitionRequests = autoCreateLVMPartitionRequests(autorequests)
         else:
-            partitions.autoPartitionRequests = autoCreatePartitionRequests(autorequests)        
+            storage.autoPartitionRequests = autoCreatePartitionRequests(autorequests)        
 
 
     def setInstallData(self, anaconda):
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/installmethod.py anaconda-storage/installmethod.py
--- anaconda/installmethod.py	2009-02-11 21:36:30.000000000 -0600
+++ anaconda-storage/installmethod.py	2009-02-15 15:17:18.000000000 -0600
@@ -47,9 +47,9 @@
         isys.ejectCdrom(dev)
 
     mtab = "/dev/root / ext3 ro 0 0\n"
-    for ent in anaconda.id.fsset.entries:
-        if ent.mountpoint == "/":
-            mtab = "/dev/root / %s ro 0 0\n" %(ent.fsystem.name,)
+    rootDevice = anaconda.id.storage.rootDevice
+    if rootDevice:
+        mtab = "/dev/root / %s ro 0 0\n" % rootDevice.format.type
 
     f = open(anaconda.rootPath + "/etc/mtab", "w+")
     f.write(mtab)
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/instdata.py anaconda-storage/instdata.py
--- anaconda/instdata.py	2009-02-13 23:02:48.000000000 -0600
+++ anaconda-storage/instdata.py	2009-02-17 13:15:06.000000000 -0600
@@ -30,10 +30,8 @@
 import security
 import timezone
 import desktop
-import fsset
+import devicetree
 import bootloader
-import partitions
-import partedUtils
 import iscsi
 import zfcp
 import urllib
@@ -67,8 +65,11 @@
 
         self.instClass = None
         self.network = network.Network()
+
+        # can we move these into self.storage?
         self.iscsi = iscsi.iscsi()
         self.zfcp = zfcp.ZFCP()
+
         self.firewall = firewall.Firewall()
         self.security = security.Security()
         self.timezone = timezone.Timezone()
@@ -80,10 +81,7 @@
         self.upgrade = None
         if flags.cmdline.has_key("preupgrade"):
             self.upgrade = True
-        # XXX move fsset and/or diskset into Partitions object?
-        self.fsset.reset()
-        self.diskset = partedUtils.DiskSet(self.anaconda)
-        self.partitions = partitions.Partitions(self.anaconda)
+        self.storage = storage.Storage(self.anaconda)
         self.bootloader = bootloader.getBootloader()
         self.upgradeRoot = None
         self.rootParts = None
@@ -102,19 +100,20 @@
         if os.path.exists("/dev/live") and \
            stat.S_ISBLK(os.stat("/dev/live")[stat.ST_MODE]):
             target = os.readlink("/dev/live")
-            self.partitions.protected = [target]
+            self.storage.protectedPartitions = [target]
         elif self.anaconda.methodstr and self.anaconda.methodstr.startswith("hd:"):
+            # FIXME: look up this device using the device tree
             method = self.anaconda.methodstr[3:]
-            device = method.split(":", 3)[0]
+            devspec = method.split(":", 3)[0]
+            
+            device = storage.resolveDevice(devspec)
+            if not device:
+                try:
+                    device = self.devicetree.getDeviceByName(devspec)
+                except AttributeError:
+                    device = None
 
-            if device.startswith("LABEL="):
-                dev = isys.getDeviceByToken("LABEL", device[6:])
-            elif device.startswith("UUID="):
-                dev = isys.getDeviceByToken("UUID", device[5:])
-            else:
-                dev = device
-
-            if dev is None:
+            if device is None:
                 if self.getUpgrade():
                     return
                 else:
@@ -125,10 +124,7 @@
                         type="custom", custom_buttons = [_("_Exit installer")])
                     sys.exit(1)
 
-            if dev.startswith("/dev/"):
-                dev = dev[5:]
-
-            self.partitions.protected = [dev]
+            self.storage.protectedPartitions = [device.name]
 
     def setInstallProgressClass(self, c):
         self.instProgress = c
@@ -312,7 +308,7 @@
         self.security.writeKS(f)
         self.timezone.writeKS(f)
         self.bootloader.writeKS(f)
-        self.partitions.writeKS(f)
+        self.storage.writeKS(f)
 
         if self.backend is not None:
             self.backend.writeKS(f)
@@ -339,6 +335,5 @@
         self.videocard = None
         self.isHeadless = 0
         self.extraModules = extraModules
-        self.fsset = fsset.FileSystemSet()
 
         self.reset()
diff -urN --exclude .git --exclude po/ --exclude '*.pyc' --exclude '.*.swp' anaconda/iscsi.py anaconda-storage/iscsi.py
--- anaconda/iscsi.py	2009-02-13 23:03:10.000000000 -0600
+++ anaconda-storage/iscsi.py	2009-02-17 12:45:03.000000000 -0600
@@ -297,22 +297,13 @@
 
         if not flags.test:
             root_drives = [ ]
-            req = anaconda.id.partitions.getRequestByMountPoint("/")
-            root_requests = anaconda.id.partitions.getUnderlyingRequests(req)
-            for req in root_requests:
-                for drive in req.drive:
-                    part = anaconda.id.diskset.disks[drive].getPartitionByPath("/dev/%s" % req.device)
-                    if part:
-                        break
-                if not part:
-                    continue
-                if drive not in root_drives:
-                    root_drives.append(drive)
-
+            root = anaconda.id.storage.fsset.rootDevice
+            root_deps = anaconda.id.storage.devicetree.getDependentDevices(root)
+            root_drives = [d.path for d in root_deps if d.type == "disk"]
             log.debug("iscsi.write: root_drives: %s" % (string.join(root_drives),))
 
             # set iscsi nodes not used for root to autostart
-            for disk in anaconda.id.diskset.disks.keys():
+            for disk in [d.path for d in anaconda.id.storage.disks]:
                 if isys.driveIsIscsi(disk) and not disk in root_drives:
                     iscsi_make_node_autostart(disk)
 
